class Connect < ActiveRecord::Base
  self.primary_key = :id
  has_many :reports

  def exec(sql)
    result = []
    if (self.adapter==Db::AdapterType[:Oracle])
      result = Db.oracle_query self.serializable_hash, sql
    elsif (self.adapter==Db::AdapterType[:Mysql])
      result = Db.mysql_query self.serializable_hash, sql
    elsif (self.adapter==Db::AdapterType[:PostgreSQL])
      result = Db.postgresql_query self.serializable_hash, sql
    elsif (self.adapter==Db::AdapterType[:Sqlserver])
      result = Db.sqlserver_query self.serializable_hash, sql
    end
    return result
  end

  def self.connect_options
    Connect.all.map { |c| [c.name, c.id] }
  end

  def adapter_name
    return "Mysql" if self.adapter == Db::AdapterType[:Mysql]
    return "PostgreSQL" if self.adapter == Db::AdapterType[:PostgreSQL]
    return "Oracle" if self.adapter == Db::AdapterType[:Oracle]
    return "Sqlserver" if self.adapter == Db::AdapterType[:Sqlserver]
  end
end
