class Db
  AdapterType={
      Mysql: "mysql2",
      PostgreSQL: "postgresql",
      Sqlserver: "sqlserver",
      Oracle: "oracle"
  }

  def self.adapter_options
    [["Mysql", AdapterType[:Mysql]], ["PostgreSQL", AdapterType[:PostgreSQL]], ["Sqlserver", AdapterType[:Sqlserver]], ["Oracle", AdapterType[:Oracle]]]
  end

  def self.oracle_query(conectstr, sql)
    require 'ruby-oci8'
    result = []
    conn = OCI8.new(conectstr["username"], conectstr["password"], "#{conectstr["host"]}:#{conectstr["port"]}/#{conectstr["database"]}")
    cursor = conn.parse(sql)
    cursor.exec
    while r = cursor.fetch_hash()
      r.each do |n, v|
        unless v
          r[n] = "其他"
        end
      end
      result << r
    end
    result
  end

  def self.mysql_query(conectstr, sql)
    result = []
    Mysql2::Client.new(conectstr.symbolize_keys).query(sql).each do |r|
      result << r
    end
    result
  end

  def self.postgresql_query(conectstr, sql)
    conn = PG::Connection.new(host:conectstr["host"],dbname:conectstr["database"],user:conectstr["username"],password:conectstr["password"])
    conn.exec(sql).to_a
  end

  def self.sqlserver_query(conectstr, sql)
    connstr = {}
    conectstr.each { |k, v| connstr[k.to_sym]=v }
    result = []
    TinyTds::Client.new(connstr).execute(sql).each do |row|
      result << row
    end
    result
  end
end
