class Map < ActiveRecord::Base
  self.primary_key = :id
  belongs_to :connect
  has_many :map_requirements, dependent: :destroy

  validates :name, uniqueness: {message: "报表名称已存在!"}

  MAPTYPE = {
    "点" => 0,
    "线" => 5,
    "面" => 10
  }

  def get_maps(params)
    sql_code = self.map_sql
    self.map_requirements.each do |r|
      if r.is_null && params[r.sql_key].blank?
        sql_code = sql_code.gsub(r.sql_default, r.sql_replace)
      else
        sql_code = sql_code.gsub("${#{r.sql_key}}", "#{params[r.sql_key.to_sym]}" || "")
      end
    end
    self.connect.exec(sql_code).clone
  end

end