class CreateReports < ActiveRecord::Migration[5.1]
  def change
    create_table :connects do |t|
      t.string :name
      t.string :adapter
      t.string :database
      t.string :username
      t.string :password
      t.string :host
      t.string :port

      t.timestamps null: false
    end

    create_table :reports do |t|
      t.string :name
      t.text :sql_code
      t.boolean :is_sql_category
      t.string :category_name
      t.references :connect, index: true, foreign_key: true
      t.string :template
      # t.string :url
      t.text :series
      t.text :dictionary

      t.timestamps null: false
    end

    create_table :requirements do |t|
      t.references :report, index: true, foreign_key: true
      t.string :name
      t.string :sql_key
      t.boolean :is_null
      t.string :sql_default
      t.string :sql_replace
      t.text :sql_str
      t.integer :sql_type
      t.integer :form_type
      t.text :dictionary

      t.timestamps null: false
    end

    create_table :maps do |t|
      t.string :name
      t.references :connect, index: true, foreign_key: true
      t.string :template
      t.integer :map_type
      t.text :map_sql

      t.timestamps null: false
    end

    create_table :map_requirements do |t|
      t.references :map, index: true, foreign_key: true
      t.string :name
      t.string :sql_key
      t.boolean :is_null
      t.string :sql_default
      t.string :sql_replace
      t.text :sql_str
      t.integer :sql_type
      t.integer :form_type
      t.text :dictionary

      t.timestamps null: false
    end

  end
end
